import logging
import os


# This defines the root path for the log file, which is relative to this file
ROOT_PATH = os.path.dirname(os.path.dirname(os.path.realpath(__file__)))
if ROOT_PATH.lower().endswith('.ts4script'):
    ROOT_PATH = os.path.dirname(ROOT_PATH)
DEFAULT_LOGS_FILENAME = 'pandas_mod.log'


# Helper function to create a logger
def Logger(name, log_file, level=logging.DEBUG):
    handler = logging.FileHandler(log_file, mode='w')

    logger = logging.getLogger(name)
    logger.setLevel(level)
    logger.addHandler(handler)
    return logger

# Now your logger is created and ready to use below
logger = Logger('PandasGreatMod', os.path.join(ROOT_PATH, DEFAULT_LOGS_FILENAME))
